/*ghassan fakher
 * gkf01
 section 6*/
public class Rectangle 
{
	private int height;
	private int width;
	private int x;
	private int y;
	//constructor using coordinates
	public Rectangle(int x, int y, int width, int height)
	{
		this.x = x;
		this. y = y;
		this.width = width;
		this.height = height;
	}
	//constructor using a point
	public Rectangle(Point p, int width, int height)
	{
		this.width = width;
		this.height = height;
		this.x = p.getX();	//using the point class already written
		this.y = p.getY();
	}
	//retruns the height of the rectangle
	public int getHeight()
	{
		return height;
	}
	//retruns the width of the rectangle
	public int getWidth()
	{
		return width;
	}
	//returns the abscissa of the point of the top left corner
	public int getX()
	{
		return x;
	}
	//returns the ordinate of the point of the top left corner
	public int getY()
	{
		return y;
	}
	//retruns a string representation of the rectangle 
	public String toString()
	{
		return "Rectangle[x = " + x + ", y = " + y + ", width = " + width + ", height = " + height + "]";
	}
	//checks whether the rectangle contains the given coordinates
	public boolean contains(int x, int y)
	{
		boolean contains = false;
		if(this.x <= x && this.y >= y && Math.sqrt(Math.pow((this.x - x ), 2)) <= width && Math.sqrt(Math.pow((this.y - y), 2)) <= height)
			contains = true;
		return contains;
	}
	//checks whether the rectangle contains the point given
	public boolean contains(Point p)
	{
		boolean contains = false;
		if(this.x <= p.getX() && this.y >= p.getY() && Math.sqrt(Math.pow((this.x - p.getX() ), 2)) <= width && Math.sqrt(Math.pow((this.y - p.getY()), 2)) <= height)
			contains = true;
		return contains;
	}
	public Rectangle union(Rectangle r)
	{
		int x2 = r.getX();
		int y2 = r.getY();
		int w2 = r.getWidth();
		int h2 = r.getHeight();
		int union_X = Math.min(x,x2); // the upper most left point (taking the origin in the buttom left)
		int union_Y = Math.min(y, y2);
		int union_W = Math.max(width+x, w2+x2)-union_X; // max width from the 1st rectangle to the second.
		int union_H = Math.max(height+y,h2+y2)-union_Y;//  max height from the 1st rectangle to the second.
		Rectangle union = new Rectangle (union_X,union_Y,union_W,union_H);
		return union;
	}
	public Rectangle intersection(Rectangle rect)
	{
		int w2 = rect.getWidth();
		int x2 = rect.getX();
		int h2 = rect.getHeight();
		int y2 = rect.getY();
		int inter_X = Math.max(x,x2);// x intersection
		int inter_Y = Math.max(y,y2);// y intersection
		int inter_Width = Math.min(width+x, w2+x2)-inter_X;// min width from the 1st rectangle to the second.
		int inter_Height = Math.min(height+y, h2+y2)-inter_Y;// min height from the 1st rectangle to the second.
		Rectangle intersection = new Rectangle (inter_X,inter_Y,inter_Width,inter_Height);
		return intersection;
	}
}
